Index: include/avr/iox128a1.h
===================================================================
--- include/avr/iox128a1.h	(revision 2452)
+++ include/avr/iox128a1.h	(working copy)
@@ -266,6 +266,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox128a1u.h
===================================================================
--- include/avr/iox128a1u.h	(revision 2452)
+++ include/avr/iox128a1u.h	(working copy)
@@ -284,6 +284,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox128a3.h
===================================================================
--- include/avr/iox128a3.h	(revision 2452)
+++ include/avr/iox128a3.h	(working copy)
@@ -266,6 +266,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox128a3u.h
===================================================================
--- include/avr/iox128a3u.h	(revision 2452)
+++ include/avr/iox128a3u.h	(working copy)
@@ -301,6 +301,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox128a4u.h
===================================================================
--- include/avr/iox128a4u.h	(revision 2452)
+++ include/avr/iox128a4u.h	(working copy)
@@ -301,6 +301,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox128b1.h
===================================================================
--- include/avr/iox128b1.h	(revision 2452)
+++ include/avr/iox128b1.h	(working copy)
@@ -264,6 +264,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox128b3.h
===================================================================
--- include/avr/iox128b3.h	(revision 2452)
+++ include/avr/iox128b3.h	(working copy)
@@ -264,6 +264,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox128c3.h
===================================================================
--- include/avr/iox128c3.h	(revision 2452)
+++ include/avr/iox128c3.h	(working copy)
@@ -277,6 +277,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox128d3.h
===================================================================
--- include/avr/iox128d3.h	(revision 2452)
+++ include/avr/iox128d3.h	(working copy)
@@ -248,6 +248,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox128d4.h
===================================================================
--- include/avr/iox128d4.h	(revision 2452)
+++ include/avr/iox128d4.h	(working copy)
@@ -259,6 +259,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox16a4.h
===================================================================
--- include/avr/iox16a4.h	(revision 2452)
+++ include/avr/iox16a4.h	(working copy)
@@ -266,6 +266,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox16a4u.h
===================================================================
--- include/avr/iox16a4u.h	(revision 2452)
+++ include/avr/iox16a4u.h	(working copy)
@@ -301,6 +301,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox16c4.h
===================================================================
--- include/avr/iox16c4.h	(revision 2452)
+++ include/avr/iox16c4.h	(working copy)
@@ -277,6 +277,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox16d4.h
===================================================================
--- include/avr/iox16d4.h	(revision 2452)
+++ include/avr/iox16d4.h	(working copy)
@@ -266,6 +266,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox192a3.h
===================================================================
--- include/avr/iox192a3.h	(revision 2452)
+++ include/avr/iox192a3.h	(working copy)
@@ -266,6 +266,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox192a3u.h
===================================================================
--- include/avr/iox192a3u.h	(revision 2452)
+++ include/avr/iox192a3u.h	(working copy)
@@ -301,6 +301,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox192c3.h
===================================================================
--- include/avr/iox192c3.h	(revision 2452)
+++ include/avr/iox192c3.h	(working copy)
@@ -277,6 +277,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox192d3.h
===================================================================
--- include/avr/iox192d3.h	(revision 2452)
+++ include/avr/iox192d3.h	(working copy)
@@ -248,6 +248,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox256a3.h
===================================================================
--- include/avr/iox256a3.h	(revision 2452)
+++ include/avr/iox256a3.h	(working copy)
@@ -266,6 +266,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox256a3b.h
===================================================================
--- include/avr/iox256a3b.h	(revision 2452)
+++ include/avr/iox256a3b.h	(working copy)
@@ -267,6 +267,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox256a3bu.h
===================================================================
--- include/avr/iox256a3bu.h	(revision 2452)
+++ include/avr/iox256a3bu.h	(working copy)
@@ -301,6 +301,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox256a3u.h
===================================================================
--- include/avr/iox256a3u.h	(revision 2452)
+++ include/avr/iox256a3u.h	(working copy)
@@ -301,6 +301,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox256c3.h
===================================================================
--- include/avr/iox256c3.h	(revision 2452)
+++ include/avr/iox256c3.h	(working copy)
@@ -277,6 +277,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox256d3.h
===================================================================
--- include/avr/iox256d3.h	(revision 2452)
+++ include/avr/iox256d3.h	(working copy)
@@ -243,6 +243,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox32a4.h
===================================================================
--- include/avr/iox32a4.h	(revision 2452)
+++ include/avr/iox32a4.h	(working copy)
@@ -266,6 +266,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox32a4u.h
===================================================================
--- include/avr/iox32a4u.h	(revision 2452)
+++ include/avr/iox32a4u.h	(working copy)
@@ -301,6 +301,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox32c4.h
===================================================================
--- include/avr/iox32c4.h	(revision 2452)
+++ include/avr/iox32c4.h	(working copy)
@@ -277,6 +277,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox32d4.h
===================================================================
--- include/avr/iox32d4.h	(revision 2452)
+++ include/avr/iox32d4.h	(working copy)
@@ -248,6 +248,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox384c3.h
===================================================================
--- include/avr/iox384c3.h	(revision 2452)
+++ include/avr/iox384c3.h	(working copy)
@@ -277,6 +277,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox384d3.h
===================================================================
--- include/avr/iox384d3.h	(revision 2452)
+++ include/avr/iox384d3.h	(working copy)
@@ -259,6 +259,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox64a1.h
===================================================================
--- include/avr/iox64a1.h	(revision 2452)
+++ include/avr/iox64a1.h	(working copy)
@@ -266,6 +266,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox64a1u.h
===================================================================
--- include/avr/iox64a1u.h	(revision 2452)
+++ include/avr/iox64a1u.h	(working copy)
@@ -284,6 +284,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox64a3.h
===================================================================
--- include/avr/iox64a3.h	(revision 2452)
+++ include/avr/iox64a3.h	(working copy)
@@ -266,6 +266,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox64a3u.h
===================================================================
--- include/avr/iox64a3u.h	(revision 2452)
+++ include/avr/iox64a3u.h	(working copy)
@@ -301,6 +301,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox64a4u.h
===================================================================
--- include/avr/iox64a4u.h	(revision 2452)
+++ include/avr/iox64a4u.h	(working copy)
@@ -301,6 +301,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox64b1.h
===================================================================
--- include/avr/iox64b1.h	(revision 2452)
+++ include/avr/iox64b1.h	(working copy)
@@ -264,6 +264,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox64b3.h
===================================================================
--- include/avr/iox64b3.h	(revision 2452)
+++ include/avr/iox64b3.h	(working copy)
@@ -264,6 +264,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox64c3.h
===================================================================
--- include/avr/iox64c3.h	(revision 2452)
+++ include/avr/iox64c3.h	(working copy)
@@ -277,6 +277,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox64d3.h
===================================================================
--- include/avr/iox64d3.h	(revision 2452)
+++ include/avr/iox64d3.h	(working copy)
@@ -248,6 +248,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/iox64d4.h
===================================================================
--- include/avr/iox64d4.h	(revision 2452)
+++ include/avr/iox64d4.h	(working copy)
@@ -259,6 +259,13 @@
 } SLEEP_SMODE_t;
 
 
+#define SLEEP_MODE_IDLE (0x00<<1)
+#define SLEEP_MODE_PWR_DOWN (0x02<<1)
+#define SLEEP_MODE_PWR_SAVE (0x03<<1)
+#define SLEEP_MODE_STANDBY (0x06<<1)
+#define SLEEP_MODE_EXT_STANDBY (0x07<<1)
+
+
 /*
 --------------------------------------------------------------------------
 OSC - Oscillator
Index: include/avr/sleep.h
===================================================================
--- include/avr/sleep.h	(revision 2452)
+++ include/avr/sleep.h	(working copy)
@@ -449,53 +449,8 @@
         _SLEEP_CONTROL_REG = ((_SLEEP_CONTROL_REG & ~(_BV(SM0) | _BV(SM1) | _BV(SM2))) | (mode)); \
     } while(0)
 
-#elif defined(__AVR_ATxmega16A4__) \
-|| defined(__AVR_ATxmega16A4U__) \
-|| defined(__AVR_ATxmega16C4__) \
-|| defined(__AVR_ATxmega16D4__) \
-|| defined(__AVR_ATxmega32A4__) \
-|| defined(__AVR_ATxmega32A4U__) \
-|| defined(__AVR_ATxmega32C4__) \
-|| defined(__AVR_ATxmega32D4__) \
-|| defined(__AVR_ATxmega64A1__) \
-|| defined(__AVR_ATxmega64A1U__) \
-|| defined(__AVR_ATxmega64A3__) \
-|| defined(__AVR_ATxmega64A3U__) \
-|| defined(__AVR_ATxmega64A4U__) \
-|| defined(__AVR_ATxmega64B1__) \
-|| defined(__AVR_ATxmega64B3__) \
-|| defined(__AVR_ATxmega64C3__) \
-|| defined(__AVR_ATxmega64D3__) \
-|| defined(__AVR_ATxmega64D4__) \
-|| defined(__AVR_ATxmega128A1__) \
-|| defined(__AVR_ATxmega128A1U__) \
-|| defined(__AVR_ATxmega128A3__) \
-|| defined(__AVR_ATxmega128A3U__) \
-|| defined(__AVR_ATxmega128A4U__) \
-|| defined(__AVR_ATxmega128B1__) \
-|| defined(__AVR_ATxmega128B3__) \
-|| defined(__AVR_ATxmega128C3__) \
-|| defined(__AVR_ATxmega128D3__) \
-|| defined(__AVR_ATxmega128D4__) \
-|| defined(__AVR_ATxmega192A3__) \
-|| defined(__AVR_ATxmega192A3U__) \
-|| defined(__AVR_ATxmega192C3__) \
-|| defined(__AVR_ATxmega192D3__) \
-|| defined(__AVR_ATxmega256A3__) \
-|| defined(__AVR_ATxmega256A3U__) \
-|| defined(__AVR_ATxmega256C3__) \
-|| defined(__AVR_ATxmega256D3__) \
-|| defined(__AVR_ATxmega256A3B__) \
-|| defined(__AVR_ATxmega256A3BU__) \
-|| defined(__AVR_ATxmega384C3__) \
-|| defined(__AVR_ATxmega384D3__)
+#elif defined(__AVR_XMEGA__)
 
-    #define SLEEP_MODE_IDLE         (0)
-    #define SLEEP_MODE_PWR_DOWN     (SLEEP_SMODE1_bm)
-    #define SLEEP_MODE_PWR_SAVE     (SLEEP_SMODE1_bm | SLEEP_SMODE0_bm)
-    #define SLEEP_MODE_STANDBY      (SLEEP_SMODE2_bm | SLEEP_SMODE1_bm)
-    #define SLEEP_MODE_EXT_STANDBY  (SLEEP_SMODE2_bm | SLEEP_SMODE1_bm | SLEEP_SMODE0_bm)
-
     #define set_sleep_mode(mode) \
     do { \
         _SLEEP_CONTROL_REG = ((_SLEEP_CONTROL_REG & ~(SLEEP_SMODE2_bm | SLEEP_SMODE1_bm | SLEEP_SMODE0_bm)) | (mode)); \