diff -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/daemon/common/commonBitzi.ml ./src/daemon/common/commonBitzi.ml
--- ./src/daemon/common/commonBitzi.ml	2005-07-22 16:32:12.000000000 +0200
+++ ./src/daemon/common/commonBitzi.ml	2005-07-28 19:28:50.000000000 +0200
@@ -251,7 +251,7 @@
               lprintf "********** Retrieve bitzi lookup by ed2k\n";
               Http_client.wget_string
                 (make_request
-                  (Printf.sprintf "http://bitzi.com/lookup/urn:ed2k:%s" (Md4.to_string ed2k)))
+                  (Printf.sprintf "http://bitzi.com/lookup/ed2k:%s" (Md4.to_string ed2k)))
               (parse_bitzi_lookup ticket) progress
           | Md5Ext md5ext ->
 
diff -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/daemon/common/commonGlobals.ml ./src/daemon/common/commonGlobals.ml
--- ./src/daemon/common/commonGlobals.ml	2005-07-23 16:19:48.000000000 +0200
+++ ./src/daemon/common/commonGlobals.ml	2005-07-28 19:06:03.000000000 +0200
@@ -493,6 +493,19 @@
     ) l;
     Printf.bprintf buf "\\</tr\\>"
 
+(* Add colspan functionality to html_mods_table_header *)
+
+let html_mods_table_header_colspan buf n c l =
+    (* Name Class List *)
+    Printf.bprintf buf "\\<div class=\\\"%s\\\"\\>\\<table id=\\\"%s\\\" name=\\\"%s\\\" class=\\\"%s\\\" cellspacing=0 cellpadding=0\\>\\<tr\\>"
+    c n n c;
+    List.iter (fun (v,w,x,y,z)  ->
+     (* Sort Class Title Value *)
+     Printf.bprintf buf "\\<td colspan=%s onClick=\\\"_tabSort(this,%s);\\\" class=\\\"%s\\\" title=\\\"%s\\\"\\>%s\\</td\\>"
+     v w x y z;
+    ) l;
+    Printf.bprintf buf "\\</tr\\>"
+
 let html_mods_table_no_header buf n c l =
     (* 1 row * n cols *)
     (* Name Class List *)
diff -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/daemon/driver/driverCommands.ml ./src/daemon/driver/driverCommands.ml
--- ./src/daemon/driver/driverCommands.ml	2005-07-27 21:57:24.000000000 +0200
+++ ./src/daemon/driver/driverCommands.ml	2005-07-28 19:27:57.000000000 +0200
@@ -2089,7 +2089,7 @@
                       ed2k (Filename.basename impl.impl_shared_codedname)));
                   ("", "sr", (if impl.impl_shared_id = Md4.null then "" else
                     Printf.sprintf "\\<a href=\\\"http://stats.razorback2.com/ed2khistory?ed2k=%s\\\"\\>%s\\</a\\>
-                                    \\<a href=\\\"http://bitzi.com/lookup/urn:ed2k:%s\\\"\\>%s\\</a\\>"
+                                    \\<a href=\\\"http://bitzi.com/lookup/ed2k:%s\\\"\\>%s\\</a\\>"
                       (Md4.to_string impl.impl_shared_id) "R" (Md4.to_string impl.impl_shared_id) "B")) ];
                 Printf.bprintf buf "\\</tr\\>\n";
               end
diff -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/daemon/driver/driverInteractive.ml ./src/daemon/driver/driverInteractive.ml
--- ./src/daemon/driver/driverInteractive.ml	2005-07-20 23:08:32.000000000 +0200
+++ ./src/daemon/driver/driverInteractive.ml	2005-07-28 19:28:18.000000000 +0200
@@ -987,14 +987,14 @@
   if use_html_mods o then
   begin
     if !!html_mods_use_js_tooltips then Printf.bprintf buf "\\<div id=\\\"object1\\\" style=\\\"position:absolute; background-color:FFFFDD;color:black;border-color:black;border-width:20;font-size:8pt; visibility:show; left:25px; top:-100px; z-index:+1\\\" onmouseover=\\\"overdiv=1;\\\"  onmouseout=\\\"overdiv=0; setTimeout(\\\'hideLayer()\\\',1000)\\\"\\>\\&nbsp;\\</div\\>\n";
-    html_mods_table_header buf "resultsTable" "results" [
-      ( "0", "srh", "Network", "Network" ) ;
-      ( "0", "srh", "File", "File (mouseover)" ) ;
-      ( "1", "srh ar", "Size", "Size" ) ;
-      ( "1", "srh ar", "Availability", "A" ) ;
-      ( "1", "srh ar", "Complete Sources", "C" ) ;
-      ( "0", "srh", "Hash (click for bitzi lookup)", "Hash (bitzi click)" ) ;
-      ( "0", "srh", "Tags", "Tags (mouseover)" ) ] ;
+    html_mods_table_header_colspan buf "resultsTable" "results" [
+      ( "1", "0", "srh", "Network", "Network" ) ;
+      ( "1", "0", "srh", "File", "File (mouseover)" ) ;
+      ( "1", "1", "srh ar", "Size", "Size" ) ;
+      ( "1", "1", "srh ar", "Availability", "A" ) ;
+      ( "1", "1", "srh ar", "Complete Sources", "C" ) ;
+      ( "3", "0", "srh", "Hash (click for lookup)", "Hash check" ) ;
+      ( "1", "0", "srh", "Tags", "Tags (mouseover)" ) ] ;
   end;
   (try
       List.iter (fun (rs,r,avail) ->
@@ -1097,6 +1097,13 @@
                   else Printf.bprintf buf "\\</a href\\>";
                 end;
               let hash = ref (string_of_uids r.result_uids) in
+	      let real_hash =
+		if String.contains !hash ':' then
+		  String.sub !hash ((String.rindex !hash ':')+1)
+		  ((String.length !hash) - (String.rindex !hash ':') - 1)
+                else
+		  !hash
+	      in
               let cavail = ref (string_of_int avail) in
               let csource = ref "" in
               List.iter (fun t ->
@@ -1111,16 +1118,15 @@
                 Printf.bprintf buf "\\<td class=\\\"sr ar\\\"\\>%s\\</td\\>
 			\\<td class=\\\"sr ar\\\"\\>%s\\</td\\>
 			\\<td class=\\\"sr ar\\\"\\>%s\\</td\\>
-			\\<td class=\\\"sr\\\"\\>\\<a href=\\\"http://bitzi.com/lookup/urn:ed2k:%s\\\"\\>%s\\</a\\>\\</td\\>"
+			\\<td class=\\\"sr\\\"\\>\\<a href=\\\"http://donkeyfakes.gambri.net/fakecheck.php?hash=%s\\\"\\>DF\\</a\\>\\</td\\>
+			\\<td class=\\\"sr\\\"\\>\\<a href=\\\"http://bitzi.com/lookup/ed2k:%s\\\"\\>BI\\</a\\>\\</td\\>
+			\\<td class=\\\"sr\\\"\\>\\<a href=\\\"http://www.filedonkey.com/url/%s\\\"\\>FD\\</a\\>\\</td\\>"
                   (size_of_int64 r.result_size)
-                !cavail
+		  !cavail
                   !csource
-
-                  (if String.contains !hash ':' then
-                    String.sub !hash
-                      ((String.rindex !hash ':')+1)
-                    ((String.length !hash) - (String.rindex !hash ':') - 1)
-                  else !hash) !hash
+		  real_hash
+		  real_hash
+		  real_hash
               else	Printf.bprintf  buf "          %10s %10s "
                   (Int64.to_string r.result_size)
                 (string_of_uids r.result_uids);